package com.google.user;

import java.io.UnsupportedEncodingException;
import java.util.ArrayList;
import java.util.List;

import org.springframework.http.HttpEntity;
import org.springframework.http.HttpHeaders;
import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.stereotype.Controller;
import org.springframework.ui.ModelMap;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;

@Controller
public class EmployeeController {

	// json  : http://localhost/empsweb
	@RequestMapping(value="/empsweb", method=RequestMethod.GET)
	public @ResponseBody List<Employee> getEmp() {
		List<Employee> employees = new ArrayList<Employee>();
		employees.add(new Employee("1", "kim"));
		return employees;
	}
		
	// json  : $ curl -H Accept=application/json localhost/empsweb
	@RequestMapping(value="/empsweb", method=RequestMethod.GET, headers="Accept=application/json")
	public @ResponseBody List<Employee> getEmpHeadrJson() {
		List<Employee> employees = new ArrayList<Employee>();
		employees.add(new Employee("1", "kim"));
		return employees;
	}
	
	//$ curl  -X PUT -Hmyheader:kim --data "aaaabbb" localhost/something
	@RequestMapping("/something")
	public ResponseEntity<String> handle(HttpEntity<byte[]> requestEntity) throws UnsupportedEncodingException {
	  String requestHeader = requestEntity.getHeaders().getFirst("myheader");
	  byte[] requestBody = requestEntity.getBody();
	  // do something with request header and body
	  System.out.println("request header(myheader) : " + requestHeader);

	  HttpHeaders responseHeaders = new HttpHeaders();
	  responseHeaders.set("MyResponseHeader", "MyValue");
	  return new ResponseEntity<String>("Hello World", responseHeaders, HttpStatus.CREATED);
	}
	
	// http://localhost/req?id=1
    @RequestMapping(value="req.htm", method = RequestMethod.GET)
    public String setupForm(@RequestParam("id") int id, ModelMap model) {
        model.addAttribute("id", id);
        return "id-value";
    }
}
